//
//  MetalImageCell.m
//  Paparazzi!
//
//  Created by Wevah on 2005.08.08.
//  Copyright 2005 Derailer. All rights reserved.
//
// Copyright (C) 2004-2005 Nate Weaver (Wevah)
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#import "MetalImageCell.h"


@implementation MetalImageCell

- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView {
	NSImage *img = [self image];
	
	if (img) {
		cellFrame = NSInsetRect(cellFrame, 4.0, 4.0);
		NSSize imgSize = [img size];
		NSRect imgRect;
		float width, height;
		
		if (cellFrame.size.width > imgSize.width && cellFrame.size.height > imgSize.height) {
			width = imgSize.width;
			height = imgSize.height;
		} else {
			float ratio = MIN(cellFrame.size.width / imgSize.width, cellFrame.size.height / imgSize.height);
			width = imgSize.width * ratio;
			height = imgSize.height * ratio;
		}
		
		imgRect = NSMakeRect(floorf((cellFrame.size.width - width) / 2.0) + cellFrame.origin.x, floorf((cellFrame.size.height - height) / 2.0) + cellFrame.origin.y, ceilf(width), ceilf(height));
		
		[[NSGraphicsContext currentContext] setImageInterpolation:NSImageInterpolationHigh];
		[img drawInRect:imgRect fromRect:NSZeroRect operation:NSCompositeCopy fraction:1.0];
		[[NSColor colorWithCalibratedWhite:0.4 alpha:1.0] set];
		
		NSFrameRect(NSInsetRect(imgRect, -1.0, -1.0));
	}
}

- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView {
	NSRectEdge sides[] = {NSMinYEdge, NSMaxXEdge, NSMaxYEdge, NSMinXEdge, NSMinYEdge, NSMaxXEdge, NSMaxYEdge, NSMinXEdge};
	float grays[] = {0.95, 0.9, 0.6, 0.9, 0.4, 0.4, 0.4, 0.4};
	NSRect rect = NSDrawTiledRects(cellFrame, cellFrame, sides, grays, 8);
	[[NSColor colorWithCalibratedWhite:0.95 alpha:1.0] set];
	NSRectFill(rect);
	[self drawInteriorWithFrame:rect inView:controlView];
}

@end
