//
//  MetalPopUpButtonCell.m
//  Paparazzi!
//
//  Created by Wevah on 2005.08.08.
//  Copyright 2005 Derailer. All rights reserved.
//
// Copyright (C) 2004-2005 Nate Weaver (Wevah)
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#import "MetalPopUpButtonCell.h"


@implementation MetalPopUpButtonCell

- (id)initTextCell:(NSString *)title pullsDown:(BOOL)pullsDown {
	if (self = [super initTextCell:title pullsDown:YES]) {
		[self setUsesItemFromMenu:NO];
		[self setBezelStyle:NSTexturedSquareBezelStyle];
		[self setArrowPosition:NSPopUpNoArrow];
	}
	
	return self;
}

- (void)setImage:(NSImage *)anImage {
	if (anImage) {
		NSMenuItem *item = [[NSMenuItem alloc] init];
		[item setImage:anImage];
		[item setOnStateImage:nil];
		[item setMixedStateImage:nil];
		[self setMenuItem:item];
		[item release];
	}
}

- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView {
	[[self image] setFlipped:YES];
	[[self image] drawAtPoint:NSZeroPoint fromRect:NSZeroRect operation:NSCompositeSourceOver fraction:1.0];
}

@end
